#include <math.h>

#include "sequence.h"



/*
 *  Returns the length of the longest sequence (“abc”, “321” or “aaa”) in a
 *  string.
 */
int find_seq(char *str) {
	int len = 1;
	for (char *c = str; *c != '\0'; c++) {
		if (*(c+1) - *c == 0
				|| *(c+1) - *c == 1
				|| *(c+1) - *c == -1) {
			len++;
		} else {
			break;
		}		
	}

	return len;
}



/*
 *  Returns the entropy of a sequence string.
 *
 *  char c	first character
 *  int len	length of the sequence	
 */
double rate_seq(char c, int len) {
	if (('a' <= c && c <= 'z')
			|| ('A' <= c && c <= 'Z')
			|| ('0' <= c && c <= '9')) {
		return log(36) / log(2) + (len - 1) * log(3) / log(2);
	}
	return 0;
}

