#include <math.h>

#include "word.h"



/*
 *  Finds dictionary words in a string.
 *
 *  dictionary *dict	the dictionary
 *  char *str		the string to be searched
 *  int *length		array to be filled with the lengths of all matches
 *
 *  return		number of matches (entries in the integer array length)
 */
int find_wrd(dictionary *dict, char *str, int *lengths) {
	int len = 0;
	int cnt = 0;
	for (char *c = str; normalize_letter(*c) != '\0'; c++) {
		int i = normalize_letter(*c) - 'a';
		len++;
		if (!(dict->next[i])) {
			break;
		}
		dict = dict->next[i];
		if (dict->end) {
			*lengths = len;
			lengths++;
			cnt++;
		}
	}
	return cnt;
}



/*
 *  returns the entropy of a dictionary word
 */
double rate_wrd(long dict_words) {
	return log(dict_words) / log(2);
}

